stages:
  - quality
  - prebuild
  - build
  - deploy

variables:
  NODE_VERSION: "14"
  BUILDER_IMAGE: ${CI_REGISTRY_IMAGE}/builder
  TAGGED_BUILDER_IMAGE: ${CI_REGISTRY_IMAGE}/builder:${CI_COMMIT_SHORT_SHA}
  API_SERVER_IMAGE: ${CI_REGISTRY_IMAGE}/api-server
  TAGGED_API_SERVER_IMAGE: ${CI_REGISTRY_IMAGE}/api-server:${CI_COMMIT_SHORT_SHA}

.bootstrap_project_dev: &bootstrap_project_dev
  before_script:
    - npm ci && npm run bootstrap

.only_master: &only_master
  only: ['master']

.only_versions: &only_versions
  only: ['tags']

.except_master_and_versions: &except_master_and_versions
  except: ['master', 'tags']

.node_jobs_cache: &node_jobs_cache
  cache:
    paths:
      - node_modules/
      - packages/*/node_modules

##### Quality #####
lint:
  image: node:${NODE_VERSION}
  stage: quality
  <<: *bootstrap_project_dev
  script:
    - npm run lint
  <<: *node_jobs_cache

test:
  image: node:${NODE_VERSION}
  stage: quality
  services:
    - mongo
  variables:
    MONGO_HOST: mongo
  <<: *bootstrap_project_dev
  script:
    - npx lerna run build --scope @caslab-iot/common
    - npm run test
  <<: *node_jobs_cache

##### Prebuild #####
.build_builder_steps: &build_builder_steps
  - docker login -u gitlab-ci-token -p "${CI_BUILD_TOKEN}" registry.gitlab.com
  - docker build -t ${TAGGED_BUILDER_IMAGE} -f Dockerfile .
  - docker push ${TAGGED_BUILDER_IMAGE}

.build_builder: &build_builder
  stage: prebuild
  image: docker
  services:
    - docker:dind

build_builder_manual:
  <<: *build_builder
  script:
    *build_builder_steps
  when: manual
  <<: *except_master_and_versions

build_builder_master:
  <<: *build_builder
  script:
    - *build_builder_steps
    - docker tag ${TAGGED_BUILDER_IMAGE} ${BUILDER_IMAGE}:master
    - docker push ${BUILDER_IMAGE}:master
  <<: *only_master

build_builder_version:
  <<: *build_builder
  script:
    - *build_builder_steps
    - docker tag ${TAGGED_BUILDER_IMAGE} ${BUILDER_IMAGE}:${CI_COMMIT_TAG}
    - docker push ${BUILDER_IMAGE}:${CI_COMMIT_TAG}
  <<: *only_versions

##### Build #####
.build_api_server_steps: &build_api_server_steps
  - docker login -u gitlab-ci-token -p "${CI_BUILD_TOKEN}" registry.gitlab.com
  - docker build -t ${TAGGED_API_SERVER_IMAGE} -f packages/api-server/Dockerfile --build-arg BUILDER_IMG=${TAGGED_BUILDER_IMAGE} .
  - docker push ${TAGGED_API_SERVER_IMAGE}

.build_api_server: &build_api_server
  stage: build
  image: docker
  services:
    - docker:dind

build_api_server_manual:
  <<: *build_api_server
  script:
    - *build_api_server_steps
  when: manual
  <<: *except_master_and_versions

build_api_server_master:
  <<: *build_api_server
  script:
    - *build_api_server_steps
    - docker tag ${TAGGED_API_SERVER_IMAGE} ${API_SERVER_IMAGE}:master
    - docker push ${API_SERVER_IMAGE}:master
  <<: *only_master

build_api_server_version:
  <<: *build_api_server
  script:
    - *build_api_server_steps
    - docker tag ${TAGGED_API_SERVER_IMAGE} ${API_SERVER_IMAGE}:${CI_COMMIT_TAG}
    - docker push ${API_SERVER_IMAGE}:${CI_COMMIT_TAG}
  <<: *only_versions


##### Deploy #####
# nothing for now
